Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing.text
Class DefaultStyledDocument

    java.lang.Object
      |
      +--javax.swing.text.AbstractDocument
            |
            +--javax.swing.text.DefaultStyledDocument

Direct Known Subclasses:
  HTMLDocument

public class DefaultStyledDocument
extends AbstractDocument
implements StyledDocument

A document that can be marked up with character and paragraph styles in a manner similar to the Rich Text Format. The element structure for this document represents style crossings for style runs. These style runs are mapped into a paragraph element structure (which may reside in some other structure). The style runs break at paragraph boundries since logical styles are assigned to paragraph boundries.

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. A future release of Swing will provide support for long term persistence.

See Also:
  `Document`, `AbstractDocument`, Serialized Form

Inner Class Summary
`static class` | `DefaultStyledDocument.AttributeUndoableEdit` An UndoableEdit used to remember AttributeSet changes to an Element.
`class` | `DefaultStyledDocument.ElementBuffer` Class to manage changes to the element hierarchy.
`static class` | `DefaultStyledDocument.ElementSpec` Specification for building elements.
`protected class` | `DefaultStyledDocument.SectionElement` Default root element for a document...

Inner classes inherited from class javax.swing.text.AbstractDocument
`AbstractDocument.AbstractElement, AbstractDocument.AttributeContext, AbstractDocument.BranchElement, AbstractDocument.Content, AbstractDocument.DefaultDocumentEvent, AbstractDocument.ElementEdit, AbstractDocument.LeafElement`

Field Summary
`protected DefaultStyledDocument.ElementBuffer` | `buffer`
`static int` | `BUFFER_SIZE_DEFAULT` The default size of the initial content buffer.

Fields inherited from class javax.swing.text.AbstractDocument
`BAD_LOCATION, BidiElementName, ContentElementName, ElementNameAttribute, listenerList, ParagraphElementName, SectionElementName`

Constructor Summary
`DefaultStyledDocument()` Constructs a default styled document.
`DefaultStyledDocument(AbstractDocument.Content c, StyleContext styles)` Constructs a styled document.
`DefaultStyledDocument(StyleContext styles)` Constructs a styled document with the default content storage implementation and a shared set of styles.

Method Summary
`void` | `addDocumentListener(DocumentListener listener)` Adds a document listener for notification of any changes.
`Style` | `addStyle(java.lang.String nm, Style parent)` Adds a new style into the logical style hierarchy.
`protected void` | `create(DefaultStyledDocument.ElementSpec[] data)` Initialize the document to reflect the given element structure (i.e.
`protected AbstractDocument.AbstractElement` | `createDefaultRoot()` Creates the root element to be used to represent the default document structure.
`java.awt.Color` | `getBackground(AttributeSet attr)` Gets the background color from an attribute set.
`Element` | `getCharacterElement(int pos)` Gets a character element based on a position.
`Element` | `getDefaultRootElement()` Gets the default root element.
`java.awt.Font` | `getFont(AttributeSet attr)` Gets the font from an attribute set.
`java.awt.Color` | `getForeground(AttributeSet attr)` Gets the foreground color from an attribute set.
`Style` | `getLogicalStyle(int p)` Fetches the logical style assigned to the paragraph represented by the given position.
`Element` | `getParagraphElement(int pos)` Gets a paragraph element.
`Style` | `getStyle(java.lang.String nm)` Fetches a named style previously added.
`java.util.Enumeration` | `getStyleNames()` Fetches the list of of style names.
`protected void` | `insert(int offset, DefaultStyledDocument.ElementSpec[] data)` Inserts new elements in bulk.
`protected void` | `insertUpdate(AbstractDocument.DefaultDocumentEvent chng, AttributeSet attr)` Updates document structure as a result of text insertion.
`void` | `removeDocumentListener(DocumentListener listener)` Removes a document listener.
`void` | `removeStyle(java.lang.String nm)` Removes a named style previously added to the document.
`protected void` | `removeUpdate(AbstractDocument.DefaultDocumentEvent chng)` Updates document structure as a result of text removal.
`void` | `setCharacterAttributes(int offset, int length, AttributeSet s, boolean replace)` Sets attributes for some part of the document.
`void` | `setLogicalStyle(int pos, Style s)` Sets the logical style to use for the paragraph at the given position.
`void` | `setParagraphAttributes(int offset, int length, AttributeSet s, boolean replace)` Sets attributes for a paragraph.
`protected void` | `styleChanged(Style style)` Creates a change event for the whole document and propagates it to the listeners.

Methods inherited from class javax.swing.text.AbstractDocument
`addUndoableEditListener, createBranchElement, createLeafElement, createPosition, dump, fireChangedUpdate, fireInsertUpdate, fireRemoveUpdate, fireUndoableEditUpdate, getAsynchronousLoadPriority, getAttributeContext, getBidiRootElement, getContent, getCurrentWriter, getDocumentProperties, getEndPosition, getLength, getProperty, getRootElements, getStartPosition, getText, getText, insertString, postRemoveUpdate, putProperty, readLock, readUnlock, remove, removeUndoableEditListener, render, setAsynchronousLoadPriority, setDocumentProperties, writeLock, writeUnlock`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### BUFFER_SIZE_DEFAULT

    public static final int BUFFER_SIZE_DEFAULT

  The default size of the initial content buffer.

### buffer

    protected DefaultStyledDocument.ElementBuffer buffer

Constructor Detail

### DefaultStyledDocument

    public DefaultStyledDocument(AbstractDocument.Content c,
                                 StyleContext styles)

  Constructs a styled document.
  Parameters:
    `c` - the container for the content
    `styles` - resources and style definitions which may be shared across documents

### DefaultStyledDocument

    public DefaultStyledDocument(StyleContext styles)

  Constructs a styled document with the default content storage implementation and a shared set of styles.
  Parameters:
    `styles` - the styles

### DefaultStyledDocument

    public DefaultStyledDocument()

  Constructs a default styled document. This buffers input content by a size of BUFFER_SIZE_DEFAULT and has a style context that is scoped by the lifetime of the document and is not shared with other documents.

Method Detail

### getDefaultRootElement

    public Element getDefaultRootElement()

  Gets the default root element.
  Returns:
    the root
  Overrides:
    getDefaultRootElement in class AbstractDocument
  See Also:
    `Document.getDefaultRootElement()`

### create

    protected void create(DefaultStyledDocument.ElementSpec[] data)

  Initialize the document to reflect the given element structure (i.e. the structure reported by the `getDefaultRootElement` method. If the document contained any data it will first be removed.

### insert

    protected void insert(int offset,
                          DefaultStyledDocument.ElementSpec[] data)
                   throws BadLocationException

  Inserts new elements in bulk. This is useful to allow parsing with the document in an unlocked state and prepare an element structure modification. This method takes an array of tokens that describe how to update an element structure so the time within a write lock can be greatly reduced in an asynchronous update situation.

  This method is thread safe, although most Swing methods are not. Please see Threads and Swing for more information.

  Parameters:
    `offset` - the starting offset >= 0
    `data` - the element data
  Throws:
    BadLocationException - for an invalid starting offset

### addStyle

    public Style addStyle(java.lang.String nm,
                          Style parent)

  Adds a new style into the logical style hierarchy. Style attributes resolve from bottom up so an attribute specified in a child will override an attribute specified in the parent.
  Specified by:
    addStyle in interface StyledDocument
  Parameters:
    `nm` - the name of the style (must be unique within the collection of named styles). The name may be null if the style is unnamed, but the caller is responsible for managing the reference returned as an unnamed style can't be fetched by name. An unnamed style may be useful for things like character attribute overrides such as found in a style run.
    `parent` - the parent style. This may be null if unspecified attributes need not be resolved in some other style.
  Returns:
    the style

### removeStyle

    public void removeStyle(java.lang.String nm)

  Removes a named style previously added to the document.
  Specified by:
    removeStyle in interface StyledDocument
  Parameters:
    `nm` - the name of the style to remove

### getStyle

    public Style getStyle(java.lang.String nm)

  Fetches a named style previously added.
  Specified by:
    getStyle in interface StyledDocument
  Parameters:
    `nm` - the name of the style
  Returns:
    the style

### getStyleNames

    public java.util.Enumeration getStyleNames()

  Fetches the list of of style names.

### setLogicalStyle

    public void setLogicalStyle(int pos,
                                Style s)

  Sets the logical style to use for the paragraph at the given position. If attributes aren't explicitly set for character and paragraph attributes they will resolve through the logical style assigned to the paragraph, which in turn may resolve through some hierarchy completely independent of the element hierarchy in the document.

  This method is thread safe, although most Swing methods are not. Please see Threads and Swing for more information.

  Specified by:
    setLogicalStyle in interface StyledDocument
  Parameters:
    `pos` - the offset from the start of the document >= 0
    `s` - the logical style to assign to the paragraph, null if none

### getLogicalStyle

    public Style getLogicalStyle(int p)

  Fetches the logical style assigned to the paragraph represented by the given position.
  Specified by:
    getLogicalStyle in interface StyledDocument
  Parameters:
    `p` - the location to translate to a paragraph and determine the logical style assigned >= 0. This is an offset from the start of the document.
  Returns:
    the style, null if none

### setCharacterAttributes

    public void setCharacterAttributes(int offset,
                                       int length,
                                       AttributeSet s,
                                       boolean replace)

  Sets attributes for some part of the document. A write lock is held by this operation while changes are being made, and a DocumentEvent is sent to the listeners after the change has been successfully completed.

  This method is thread safe, although most Swing methods are not. Please see Threads and Swing for more information.

  Specified by:
    setCharacterAttributes in interface StyledDocument
  Parameters:
    `offset` - the offset in the document >= 0
    `length` - the length >= 0
    `s` - the attributes
    `replace` - true if the previous attributes should be replaced before setting the new attributes

### setParagraphAttributes

    public void setParagraphAttributes(int offset,
                                       int length,
                                       AttributeSet s,
                                       boolean replace)

  Sets attributes for a paragraph.

  This method is thread safe, although most Swing methods are not. Please see Threads and Swing for more information.

  Specified by:
    setParagraphAttributes in interface StyledDocument
  Parameters:
    `offset` - the offset into the paragraph >= 0
    `length` - the number of characters affected >= 0
    `s` - the attributes
    `replace` - whether to replace existing attributes, or merge them

### getParagraphElement

    public Element getParagraphElement(int pos)

  Gets a paragraph element. The paragraph element is the parent of the deepest leaf.
  Specified by:
    getParagraphElement in interface StyledDocument
  Parameters:
    `pos` - the starting offset >= 0
  Returns:
    the element
  Overrides:
    getParagraphElement in class AbstractDocument

### getCharacterElement

    public Element getCharacterElement(int pos)

  Gets a character element based on a position.
  Specified by:
    getCharacterElement in interface StyledDocument
  Parameters:
    `pos` - the position in the document >= 0
  Returns:
    the element

### insertUpdate

    protected void insertUpdate(AbstractDocument.DefaultDocumentEvent chng,
                                AttributeSet attr)

  Updates document structure as a result of text insertion. This will happen within a write lock. This implementation simply parses the inserted content for line breaks and builds up a set of instructions for the element buffer.
  Parameters:
    `chng` - a description of the document change
    `attr` - the attributes
  Overrides:
    insertUpdate in class AbstractDocument

### removeUpdate

    protected void removeUpdate(AbstractDocument.DefaultDocumentEvent chng)

  Updates document structure as a result of text removal.
  Parameters:
    `chng` - a description of the document change
  Overrides:
    removeUpdate in class AbstractDocument

### createDefaultRoot

    protected AbstractDocument.AbstractElement createDefaultRoot()

  Creates the root element to be used to represent the default document structure.
  Returns:
    the element base

### getForeground

    public java.awt.Color getForeground(AttributeSet attr)

  Gets the foreground color from an attribute set.
  Specified by:
    getForeground in interface StyledDocument
  Parameters:
    `attr` - the attribute set
  Returns:
    the color

### getBackground

    public java.awt.Color getBackground(AttributeSet attr)

  Gets the background color from an attribute set.
  Specified by:
    getBackground in interface StyledDocument
  Parameters:
    `attr` - the attribute set
  Returns:
    the color

### getFont

    public java.awt.Font getFont(AttributeSet attr)

  Gets the font from an attribute set.
  Specified by:
    getFont in interface StyledDocument
  Parameters:
    `attr` - the attribute set
  Returns:
    the font

### styleChanged

    protected void styleChanged(Style style)

  Creates a change event for the whole document and propagates it to the listeners. Subclasses may wish to be inteligent about what gets damaged.
  Parameters:
    `style` - The Style that has changed.

### addDocumentListener

    public void addDocumentListener(DocumentListener listener)

  Adds a document listener for notification of any changes.
  Parameters:
    `listener` - the listener
  Overrides:
    addDocumentListener in class AbstractDocument
  See Also:
    `Document.addDocumentListener(javax.swing.event.DocumentListener)`

### removeDocumentListener

    public void removeDocumentListener(DocumentListener listener)

  Removes a document listener.
  Parameters:
    `listener` - the listener
  Overrides:
    removeDocumentListener in class AbstractDocument
  See Also:
    `Document.removeDocumentListener(javax.swing.event.DocumentListener)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-1998 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.